import 'package:flutter/services.dart';

class FinBoxBureauPlugin {
  static const platform = MethodChannel('in.finbox.bureauconnect/hybrid');

  static Future initSdk(
      String env,
      String apiKey,
      String customerId,
      String firstName,
      String? middleName,
      String? lastName,
      String phone) async {
    try {
      await platform.invokeMethod('initSdk', <String, dynamic>{
        'apiKey': apiKey,
        'env': env,
        'customerId': customerId,
        'firstName': firstName,
        'middleName': middleName,
        'lastName': lastName,
        'phone': phone
      });
    } on PlatformException catch (e) {
      print("Error on initializing bureau connect ${e.message}");
    }
  }

  static Future startBureauJourney() async {
    try {
      await platform.invokeMethod('startBureauJourney');
    } on PlatformException catch (e) {
      print("Error on launching bureau connect ${e.message}");
    }
  }
}
